using System;
using System.Collections.Generic;

namespace TestProject;

/// <summary>
///  
/// </summary>
public class CommandManager
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Public

    #region   ڵ鷯 ߰ϱ - AddWeakReferenceHandler(weakReferenceList, eventHandler)

    /// <summary>
    ///   ڵ鷯 ߰ϱ
    /// </summary>
    /// <param name="weakReferenceList">  Ʈ</param>
    /// <param name="eventHandler">̺Ʈ ڵ鷯</param>
    public static void AddWeakReferenceHandler(ref List<WeakReference> weakReferenceList, EventHandler eventHandler)
    {
        if(weakReferenceList == null)
        {
            weakReferenceList = new List<WeakReference>();
        }

        weakReferenceList.Add(new WeakReference(eventHandler));
    }

    #endregion
    #region   ڵ鷯 ϱ - RemoveWeakReferenceHandler(weakReferenceList, eventHandler)

    /// <summary>
    ///   ڵ鷯 ϱ
    /// </summary>
    /// <param name="weakReferenceList">  Ʈ</param>
    /// <param name="eventHandler">̺Ʈ ڵ鷯</param>
    public static void RemoveWeakReferenceHandler(List<WeakReference> weakReferenceList, EventHandler eventHandler)
    {
        if(weakReferenceList != null)
        {
            for(int i = weakReferenceList.Count - 1; i >= 0; i--)
            {
                WeakReference weakReference = weakReferenceList[i];

                EventHandler existingEventHandler  = weakReference.Target as EventHandler;
                   
                if((existingEventHandler  == null) || (existingEventHandler  == eventHandler))
                {
                    weakReferenceList.RemoveAt(i);
                }
            }
        }
    }

    #endregion
    #region   ڵ鷯 ȣϱ - CallWeakReferenceHandlers(weakReferenceList)

    /// <summary>
    ///   ڵ鷯 ȣϱ
    /// </summary>
    /// <param name="weakReferenceList">  Ʈ</param>
    public static void CallWeakReferenceHandlers(List<WeakReference> weakReferenceList)
    {
        if(weakReferenceList != null)
        {
            EventHandler[] eventHandlerArray = new EventHandler[weakReferenceList.Count];

            int count = 0;

            for(int i = weakReferenceList.Count - 1; i >= 0; i--)
            {
                WeakReference weakReference  = weakReferenceList[i];

                EventHandler eventHandler = weakReference.Target as EventHandler;
                    
                if(eventHandler == null)
                {
                    weakReferenceList.RemoveAt(i);
                }
                else
                {
                    eventHandlerArray[count] = eventHandler;

                    count++;
                }
            }

            for(int i = 0; i < count; i++)
            {
                EventHandler eventHandler = eventHandlerArray[i];

                eventHandler(null, EventArgs.Empty);
            }
        }
    }

    #endregion
}